#include "gamedata/LaylaVulnerabilitySettings.h"

namespace Lonely {


LaylaVulnerabilitySettings::LaylaVulnerabilitySettings()
  : pistol(false),
    machineGun(false),
    grenade(false),
    flamethrower(false),
    axe(false),
    bazooka(false),
    saber(false),
    shield(false) { };
  
int LaylaVulnerabilitySettings::readFromData(const Tbyte* src) {
  if ((*src) & 0x01) { pistol = true; } else { pistol = false; }
  if ((*src) & 0x02) { machineGun = true; } else { machineGun = false; }
  if ((*src) & 0x04) { grenade = true; } else { grenade = false; }
  if ((*src) & 0x08) { flamethrower = true; } else { flamethrower = false; }
  if ((*src) & 0x10) { axe = true; } else { axe = false; }
  if ((*src) & 0x20) { bazooka = true; } else { bazooka = false; }
  if ((*src) & 0x40) { saber = true; } else { saber = false; }
  if ((*src) & 0x80) { shield = true; } else { shield = false; }
  
  return size;
}

int LaylaVulnerabilitySettings::writeToData(Tbyte* dst) const {
  Tbyte d = 0;
  
  if (pistol) { d |= 0x01; }
  if (machineGun) { d |= 0x02; }
  if (grenade) { d |= 0x04; }
  if (flamethrower) { d |= 0x08; }
  if (axe) { d |= 0x10; }
  if (bazooka) { d |= 0x20; }
  if (saber) { d |= 0x40; }
  if (shield) { d |= 0x80; }
  
  *dst = d;
  
  return size;
}


};
